<?php
/*
Plugin Name: Gallery Widget
Plugin URI: http://blog.splash.de/plugins/
Description: Simple widget to show the latest images of the wordpress media gallery (Wordpress 2.5++)
Author: Oliver Schaal
Version: 0.5.2
Author URI: http://blog.splash.de/

    This is a WordPress plugin (http://wordpress.org) and widget
    (http://automattic.com/code/widgets/).
*/

function get_attached_images($_max = 5) {

	$_retval='<ul class="wGallery">';

	$r = new WP_Query("showposts=$_max&what_to_show=posts&post_status=inherit&post_type=attachment&orderby=menu_order ASC, ID ASC&post_mime_type=image/jpeg,image/gif,image/jpg,image/png");

	if ($r->have_posts()) {
			while ($r->have_posts()) : $r->the_post();

						$_retval.="<li class=\"wGallery\"><a href=\"".get_attachment_link(get_the_ID())."\"><img src=\"".wp_get_attachment_thumb_url(get_the_ID())."\" alt=\"".get_the_title()."\" /></a></li>";

			endwhile;
	}

	$_retval.='</ul>';

	return $_retval;
}


function widget_wGallery_init() {

	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
        return;


    function widget_wGallery($args) {

        extract($args);

        $options = get_option('widget_wGallery');

        $title = empty($options['title']) ? 'Gallery Widget' : $options['title'];
        $max = empty($options['max']) ? 5 : $options['max'];

        echo $before_widget;
        echo $before_title . $title . $after_title;
        echo get_attached_images($max);
        echo $after_widget;
    }

    function widget_wGallery_control() {

        $options = get_option('widget_wGallery');

        if ( $_POST['wGallery-submit'] ) {
            $newoptions['title'] = strip_tags(stripslashes($_POST['wGallery-title']));
            $newoptions['max'] = strip_tags(stripslashes($_POST['wGallery-max']));
        }

        $options['title'] = (!empty($newoptions['title'])) ? $newoptions['title'] : $options['title'];
        $options['max'] = (!empty($newoptions['max'])) ? $newoptions['max'] : $options['max'];
		update_option('widget_wGallery', $options);

        $title = htmlspecialchars($options['title'], ENT_QUOTES);
        $max = htmlspecialchars($options['max'], ENT_QUOTES);

?>
        <div>
        <label for="wGallery-title" style="line-height:35px;display:block;">widget title: <input type="text" id="wGallery-title" name="wGallery-title" value="<?php echo $title; ?>" /></label>
        <label for="wGallery-max" style="line-height:35px;display:block;">max images: <input type="text" id="wGallery-max" name="wGallery-max" value="<?php echo $max; ?>" /></label>
        <input type="hidden" name="wGallery-submit" id="wGallery-submit" value="1" />
        </div>
    <?php

    }

    // Need to register the widget and the control form.
   	register_sidebar_widget(__('Gallery Widget', 'wGallery'), 'widget_wGallery');
	register_widget_control(__('Gallery Widget', 'wGallery'), 'widget_wGallery_control', 300, 200);

}


function widget_wGallery_deactivate() {
	delete_option('widget_wGallery');
}

register_deactivation_hook(__FILE__, 'widget_wGallery_deactivate');
add_action('plugins_loaded', 'widget_wGallery_init');
?>